diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/generic-battery-model.cc ns-3.40/src/energy/model/generic-battery-model.cc
--- ns-3.39/src/energy/model/generic-battery-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.40/src/energy/model/generic-battery-model.cc	2023-09-27 13:30:37.642839000 -0700
@@ -0,0 +1,438 @@
+/*
+ * Copyright (c) 2010 Andrea Sacco: Li-Ion battery
+ * Copyright (c) 2023 Tokushima University, Japan:
+ * NiMh,NiCd,LeaAcid batteries and preset and multicell extensions.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Andrea Sacco <andrea.sacco85@gmail.com>
+ *         Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "generic-battery-model.h"
+
+#include <ns3/assert.h>
+#include <ns3/double.h>
+#include <ns3/log.h>
+#include <ns3/simulator.h>
+#include <ns3/trace-source-accessor.h>
+
+#include <cmath>
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("GenericBatteryModel");
+
+NS_OBJECT_ENSURE_REGISTERED(GenericBatteryModel);
+
+TypeId
+GenericBatteryModel::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::GenericBatteryModel")
+            .SetParent<EnergySource>()
+            .SetGroupName("Energy")
+            .AddConstructor<GenericBatteryModel>()
+            .AddAttribute("LowBatteryThreshold",
+                          "Low battery threshold for generic battery model.",
+                          DoubleValue(0.10), // 0.10 as a fraction of the initial energy
+                          MakeDoubleAccessor(&GenericBatteryModel::m_lowBatteryTh),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("FullVoltage",
+                          "(Q_full) The voltage of the cell when fully charged (V).",
+                          DoubleValue(4.18),
+                          MakeDoubleAccessor(&GenericBatteryModel::m_vFull),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("MaxCapacity",
+                          "(Q) The maximum capacity of the cell (Ah).",
+                          DoubleValue(2.45),
+                          MakeDoubleAccessor(&GenericBatteryModel::m_qMax),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("NominalVoltage",
+                          "(V_nom) Nominal voltage of the cell (V).",
+                          DoubleValue(3.59),
+                          MakeDoubleAccessor(&GenericBatteryModel::m_vNom),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("NominalCapacity",
+                          "(Q_nom) Cell capacity at the end of the nominal zone (Ah)",
+                          DoubleValue(1.3),
+                          MakeDoubleAccessor(&GenericBatteryModel::m_qNom),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("ExponentialVoltage",
+                          "(V_exp) Cell voltage at the end of the exponential zone (V).",
+                          DoubleValue(3.75),
+                          MakeDoubleAccessor(&GenericBatteryModel::m_vExp),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("ExponentialCapacity",
+                          "(Q_exp) Cell Capacity at the end of the exponential zone (Ah).",
+                          DoubleValue(0.39),
+                          MakeDoubleAccessor(&GenericBatteryModel::m_qExp),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("InternalResistance",
+                          "(R) Internal resistance of the cell (Ohms)",
+                          DoubleValue(0.083),
+                          MakeDoubleAccessor(&GenericBatteryModel::m_internalResistance),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("TypicalDischargeCurrent",
+                          "Typical discharge current used in manufacters datasheets (A)",
+                          DoubleValue(2.33),
+                          MakeDoubleAccessor(&GenericBatteryModel::m_typicalCurrent),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("CutoffVoltage",
+                          "The voltage where the battery is considered depleted (V).",
+                          DoubleValue(3.3),
+                          MakeDoubleAccessor(&GenericBatteryModel::m_cutoffVoltage),
+                          MakeDoubleChecker<double>())
+            .AddAttribute("PeriodicEnergyUpdateInterval",
+                          "Time between two consecutive periodic energy updates.",
+                          TimeValue(Seconds(1.0)),
+                          MakeTimeAccessor(&GenericBatteryModel::SetEnergyUpdateInterval,
+                                           &GenericBatteryModel::GetEnergyUpdateInterval),
+                          MakeTimeChecker())
+            .AddAttribute("BatteryType",
+                          "Indicates the battery type used by the model",
+                          EnumValue(LION_LIPO),
+                          MakeEnumAccessor(&GenericBatteryModel::m_batteryType),
+                          MakeEnumChecker(LION_LIPO,
+                                          "LION_LIPO",
+                                          NIMH_NICD,
+                                          "NIMH_NICD",
+                                          LEADACID,
+                                          "LEADACID"))
+            .AddTraceSource("RemainingEnergy",
+                            "Remaining energy of generic battery",
+                            MakeTraceSourceAccessor(&GenericBatteryModel::m_remainingEnergyJ),
+                            "ns3::TracedValueCallback::Double");
+    return tid;
+}
+
+GenericBatteryModel::GenericBatteryModel()
+    : m_drainedCapacity(0),
+      m_currentFiltered(0),
+      m_entn(0),
+      m_expZone(0),
+      m_lastUpdateTime(Seconds(0.0))
+{
+    NS_LOG_FUNCTION(this);
+}
+
+GenericBatteryModel::~GenericBatteryModel()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+double
+GenericBatteryModel::GetInitialEnergy() const
+{
+    double initialEnergy = m_qMax * m_vFull * 3600;
+    return initialEnergy;
+}
+
+double
+GenericBatteryModel::GetSupplyVoltage() const
+{
+    return m_supplyVoltageV;
+}
+
+void
+GenericBatteryModel::SetEnergyUpdateInterval(Time interval)
+{
+    NS_LOG_FUNCTION(this << interval);
+    m_energyUpdateInterval = interval;
+}
+
+void
+GenericBatteryModel::SetDrainedCapacity(double drainedCapacity)
+{
+    NS_ASSERT(drainedCapacity >= 0 && drainedCapacity < m_qMax);
+    m_drainedCapacity = drainedCapacity;
+}
+
+double
+GenericBatteryModel::GetDrainedCapacity() const
+{
+    return m_drainedCapacity;
+}
+
+double
+GenericBatteryModel::GetStateOfCharge() const
+{
+    double soc = 100 * (1 - m_drainedCapacity / m_qMax);
+    return soc;
+}
+
+Time
+GenericBatteryModel::GetEnergyUpdateInterval() const
+{
+    NS_LOG_FUNCTION(this);
+    return m_energyUpdateInterval;
+}
+
+double
+GenericBatteryModel::GetRemainingEnergy()
+{
+    NS_LOG_FUNCTION(this);
+    UpdateEnergySource();
+    return m_remainingEnergyJ;
+}
+
+double
+GenericBatteryModel::GetEnergyFraction()
+{
+    NS_LOG_FUNCTION(this);
+    return GetStateOfCharge();
+}
+
+void
+GenericBatteryModel::UpdateEnergySource()
+{
+    NS_LOG_FUNCTION(this);
+
+    // do not update if simulation has finished
+    if (Simulator::IsFinished())
+    {
+        return;
+    }
+
+    m_energyUpdateEvent.Cancel();
+
+    CalculateRemainingEnergy();
+
+    m_lastUpdateTime = Simulator::Now();
+
+    if (m_supplyVoltageV <= m_cutoffVoltage)
+    {
+        // check if battery is depleted
+        BatteryDepletedEvent();
+    }
+    else if (m_supplyVoltageV >= m_vFull)
+    {
+        // check if battery has reached full charge
+        BatteryChargedEvent();
+        // TODO: Should battery charging be stopped if full voltage is reached?
+        //       or should it be allowed to continue charging (overcharge)?
+    }
+
+    m_energyUpdateEvent =
+        Simulator::Schedule(m_energyUpdateInterval, &GenericBatteryModel::UpdateEnergySource, this);
+}
+
+void
+GenericBatteryModel::DoInitialize()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+void
+GenericBatteryModel::DoDispose()
+{
+    NS_LOG_FUNCTION(this);
+    BreakDeviceEnergyModelRefCycle();
+}
+
+void
+GenericBatteryModel::BatteryDepletedEvent()
+{
+    NS_LOG_FUNCTION(this);
+    // notify DeviceEnergyModel objects, all "usable" energy has been depleted
+    // (cutoff voltage was reached)
+    NotifyEnergyDrained();
+}
+
+void
+GenericBatteryModel::BatteryChargedEvent()
+{
+    NS_LOG_FUNCTION(this);
+    // notify DeviceEnergyModel objects, the battery has reached its full energy potential.
+    // (full voltage was reached)
+    NotifyEnergyRecharged();
+}
+
+void
+GenericBatteryModel::CalculateRemainingEnergy()
+{
+    NS_LOG_FUNCTION(this);
+
+    double totalCurrentA = CalculateTotalCurrent();
+
+    m_energyUpdateLapseTime = Simulator::Now() - m_lastUpdateTime;
+
+    NS_ASSERT(m_energyUpdateLapseTime.GetSeconds() >= 0);
+
+    // Calculate i* (current step response)
+    Time batteryResponseConstant = Seconds(30);
+
+    double responseTime = (Simulator::Now() / batteryResponseConstant).GetDouble();
+    m_currentFiltered = totalCurrentA * (1 - 1 / (std::exp(responseTime)));
+    // TODO: the time in the responseTime should be a time taken since the last *battery current*
+    // change, in the testing the  battery current is only changed at the beginning of the
+    // simulation therefore, the simulation time can be used. However this must be changed to
+    // a time counter to allow this value to reset in the middle of the simulation when the
+    // battery current changes.
+
+    m_drainedCapacity += (totalCurrentA * m_energyUpdateLapseTime).GetHours();
+
+    if (totalCurrentA < 0)
+    {
+        // Charge current (Considered as "Negative" i)
+        m_supplyVoltageV = GetChargeVoltage(totalCurrentA);
+    }
+    else
+    {
+        // Discharge current (Considered as "Positive" i)
+        m_supplyVoltageV = GetVoltage(totalCurrentA);
+    }
+}
+
+double
+GenericBatteryModel::GetChargeVoltage(double i)
+{
+    // integral of i over time drained capacity in Ah
+    double it = m_drainedCapacity;
+
+    // empirical factors
+    double A = m_vFull - m_vExp;
+    double B = 3 / m_qExp;
+
+    // voltage constant
+    double E0 = m_vFull + m_internalResistance * m_typicalCurrent - A;
+
+    // voltage of exponential zone when battery is fully charged
+    double expZoneFull = A * std::exp(-B * m_qNom);
+
+    // Obtain the voltage|resistance polarization constant
+    double K = (E0 - m_vNom - (m_internalResistance * m_typicalCurrent) + expZoneFull) /
+               (m_qMax / (m_qMax - m_qNom) * (m_qNom + m_typicalCurrent));
+
+    double V = 0;
+    double polResistance = 0;
+    double polVoltage = 0;
+
+    if (m_batteryType == LION_LIPO)
+    { // For LiOn & LiPo batteries
+
+        // Calculate exponential zone voltage
+        m_expZone = A * std::exp(-B * it);
+
+        polResistance = K * m_qMax / (it + 0.1 * m_qMax);
+        polVoltage = K * m_qMax / (m_qMax - it);
+        V = E0 - (m_internalResistance * i) - (polResistance * m_currentFiltered) -
+            (polVoltage * it) + m_expZone;
+    }
+    else
+    {
+        // Calculate exponential zone voltage
+
+        if (m_expZone == 0)
+        {
+            m_expZone = A * std::exp(-B * it);
+        }
+        double entnPrime = m_entn;
+        double expZonePrime = m_expZone;
+        m_entn = B * std::abs(i) * (-expZonePrime + A);
+        m_expZone = expZonePrime + (m_energyUpdateLapseTime * entnPrime).GetHours();
+
+        if (m_batteryType == NIMH_NICD)
+        { // For NiMH and NiCd batteries
+            polResistance = K * m_qMax / (std::abs(it) + 0.1 * m_qMax);
+        }
+        else if (m_batteryType == LEADACID)
+        { // For Lead acid batteries
+            polResistance = K * m_qMax / (it + 0.1 * m_qMax);
+        }
+
+        polVoltage = K * m_qMax / (m_qMax - it);
+
+        V = E0 - (m_internalResistance * i) - (polResistance * m_currentFiltered) -
+            (polVoltage * it) + m_expZone;
+    }
+
+    // Energy in Joules = RemainingCapacity * Voltage * Seconds in an Hour
+    m_remainingEnergyJ = (m_qMax - it) * V * 3600;
+
+    NS_LOG_DEBUG("* CHARGE *| " << Simulator::Now().As(Time::S) << "| i " << i << " | it " << it
+                                << "| E0 " << E0 << " | polRes " << polResistance << " | polVol "
+                                << polVoltage << "| B " << B << " | ExpZone " << m_expZone
+                                << " | A " << A << "| K " << K << "| i* " << m_currentFiltered
+                                << " | V " << V << " |  rmnEnergy " << m_remainingEnergyJ
+                                << "J | SoC " << GetStateOfCharge() << "% ");
+
+    return V;
+}
+
+double
+GenericBatteryModel::GetVoltage(double i)
+{
+    NS_LOG_FUNCTION(this << i);
+
+    // integral of i in dt, drained capacity in Ah
+    double it = m_drainedCapacity;
+
+    // empirical factors
+    double A = m_vFull - m_vExp;
+
+    double B = 3 / m_qExp;
+
+    // constant voltage
+    double E0 = m_vFull + m_internalResistance * m_typicalCurrent - A;
+
+    // voltage of exponential zone when battery is fully charged
+    double expZoneFull = A * std::exp(-B * m_qNom);
+
+    // Obtain the voltage|resistance polarization constant
+    double K = (E0 - m_vNom - (m_internalResistance * m_typicalCurrent) + expZoneFull) /
+               (m_qMax / (m_qMax - m_qNom) * (m_qNom + m_typicalCurrent));
+
+    double V = 0;
+    double polResistance = K * (m_qMax / (m_qMax - it));
+    double polVoltage = polResistance;
+
+    // Calculate exponential zone voltage according to the battery type
+    if (m_batteryType == LION_LIPO)
+    {
+        m_expZone = A * exp(-B * it);
+    }
+    else
+    {
+        NS_ASSERT(m_batteryType == NIMH_NICD || m_batteryType == LEADACID);
+        if (m_expZone == 0)
+        {
+            m_expZone = A * exp(-B * it);
+        }
+
+        double entnPrime = m_entn;
+        double expZonePrime = m_expZone;
+
+        m_entn = B * std::abs(i) * (-expZonePrime);
+        m_expZone = expZonePrime + (m_energyUpdateLapseTime * entnPrime).GetHours();
+    }
+
+    V = E0 - (m_internalResistance * i) - (polResistance * m_currentFiltered) - (polVoltage * it) +
+        m_expZone;
+
+    // EnergyJ = RemainingCapacity * Voltage * Seconds in an Hour
+    m_remainingEnergyJ = (m_qMax - it) * V * 3600;
+
+    NS_LOG_DEBUG("* DISCHARGE *| " << Simulator::Now().As(Time::S) << "| i " << i << " | it " << it
+                                   << " | A " << A << " | B " << B << " | ExpZone " << m_expZone
+                                   << " | V " << V << " | rmnEnergy " << m_remainingEnergyJ
+                                   << "J | SoC " << GetStateOfCharge() << "% "
+                                   << "\n"
+                                   << "             | K " << K << " | E0 " << E0);
+
+    return V;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/generic-battery-model.h ns-3.40/src/energy/model/generic-battery-model.h
--- ns-3.39/src/energy/model/generic-battery-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.40/src/energy/model/generic-battery-model.h	2023-09-27 13:30:37.642839000 -0700
@@ -0,0 +1,314 @@
+/*
+ * Copyright (c) 2010 Andrea Sacco: Li-Ion battery
+ * Copyright (c) 2023 Tokushima University, Japan:
+ * NiMh,NiCd,LeaAcid batteries and preset and multi-cell extensions.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Andrea Sacco <andrea.sacco85@gmail.com>
+ *         Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#ifndef GENERIC_BATTERY_MODEL_H
+#define GENERIC_BATTERY_MODEL_H
+
+#include "energy-source.h"
+
+#include <ns3/event-id.h>
+#include <ns3/nstime.h>
+#include <ns3/traced-value.h>
+
+namespace ns3
+{
+
+/**
+ * \ingroup energy
+ *
+ *  Battery types.
+ *  These are grouped according to their chemical characteristics
+ *  present during a charge/discharge curve.
+ */
+enum GenericBatteryType
+{
+    LION_LIPO = 0, //!< Lithium-ion and Lithium-polymer batteries
+    NIMH_NICD = 1, //!< Nickel-metal hydride and Nickel cadmium batteries
+    LEADACID = 2   //!< Lead Acid Batteries
+};
+
+/**
+ * \ingroup energy
+ *
+ *  Battery models that described the parameters of the the battery presets.
+ */
+enum BatteryModel
+{
+    PANASONIC_HHR650D_NIMH = 0,    //!< Panasonic HHR650D NiMh battery
+    CSB_GP1272_LEADACID = 1,       //!< CSB GP1272 Lead acid battery
+    PANASONIC_CGR18650DA_LION = 2, //!< Panasonic CGR18650DA Li-Ion battery
+    RSPRO_LGP12100_LEADACID = 3,   //!< RS Pro LGP12100 Lead acid battery
+    PANASONIC_N700AAC_NICD = 4     //!< Panasonic N700AAC NiCd battery
+};
+
+/**
+ * \ingroup energy
+ *
+ *  The structure containing the the parameter values that describe a
+ *  battery preset.
+ */
+struct BatteryPresets
+{
+    GenericBatteryType batteryType; //!< The type of battery used in the preset.
+    std::string description;        //!< Additional information about the battery.
+    double vFull;                   //!< Initial voltage of the battery, in Volts
+    double qMax;                    //!< The maximum capacity of the battery, in Ah
+    double vNom;                    //!< Nominal voltage of the battery, in Volts
+    double qNom;                    //!< Battery capacity at the end of the nominal zone, in Ah
+    double vExp;               //!< Battery voltage at the end of the exponential zone, in Volts
+    double qExp;               //!< Capacity value at the end of the exponential zone, in Ah
+    double internalResistance; //!< Internal resistance of the battery, in Ohms
+    double typicalCurrent;     //!< Typical discharge current used to fit the curves
+    double cuttoffVoltage;     //!< The threshold voltage where the battery is considered depleted
+};
+
+/**
+ * \ingroup energy
+ *
+ *  Contains the values that form the battery presents available in this module.
+ */
+static BatteryPresets g_batteryPreset[] = {{NIMH_NICD,
+                                            "Panasonic HHR650D | NiMH | 1.2V 6.5Ah | Size: D",
+                                            1.39,
+                                            7.0,
+                                            1.18,
+                                            6.25,
+                                            1.28,
+                                            1.3,
+                                            0.0046,
+                                            1.3,
+                                            1.0},
+                                           {LEADACID,
+                                            "CSB GP1272 | Lead Acid | 12V 7.2Ah",
+                                            12.8,
+                                            7.2,
+                                            11.5,
+                                            4.5,
+                                            12.5,
+                                            2,
+                                            0.056,
+                                            0.36,
+                                            8.0},
+                                           {LION_LIPO,
+                                            "Panasonic CGR18650DA | Li-Ion | 3.6V 2.45Ah | Size: A",
+                                            4.17,
+                                            2.33,
+                                            3.57,
+                                            2.14,
+                                            3.714,
+                                            1.74,
+                                            0.0830,
+                                            0.466,
+                                            3.0},
+                                           {LEADACID,
+                                            "Rs PRO LGP12100 | Lead Acid | 12V 100Ah",
+                                            12.60,
+                                            130,
+                                            12.44,
+                                            12.3,
+                                            12.52,
+                                            12,
+                                            0.00069,
+                                            5,
+                                            11},
+                                           {NIMH_NICD,
+                                            "PANASONIC N-700AAC | NiCd | 1.2V 700mAh | Size: AA",
+                                            1.38,
+                                            0.790,
+                                            1.17,
+                                            0.60,
+                                            1.25,
+                                            0.24,
+                                            0.016,
+                                            0.7,
+                                            0.8}};
+
+/**
+ * \ingroup energy
+ * \brief A generic battery model for  Li-Ion, NiCd, NiMh and Lead acid batteries
+ *
+ * The generic battery model can be used to describe the discharge behavior of
+ * the battery chemestries supported by the model.
+ */
+class GenericBatteryModel : public EnergySource
+{
+  public:
+    /**
+     * \brief Get the type ID.
+     * \return The object TypeId.
+     */
+    static TypeId GetTypeId();
+
+    GenericBatteryModel();
+
+    ~GenericBatteryModel() override;
+
+    /**
+     * Implements GetInitialEnergy. It returns the amount of energy in Joules stored in the
+     * battery when fully charged. This energy is different to the total amount of usable energy
+     * in the battery. This is because the battery cannot be used until Voltage = 0, only until
+     * it reaches the cutoff voltage.
+     *
+     * \return The initial energy stored in the fully charged battery, in Joules.
+     */
+    double GetInitialEnergy() const override;
+
+    /**
+     * Implements GetSupplyVoltage.
+     *
+     * \return Supply voltage at the energy source.
+     */
+    double GetSupplyVoltage() const override;
+
+    /**
+     * Implements GetRemainingEnergy.
+     *
+     * \return Remaining energy in energy source, in Joules
+     */
+    double GetRemainingEnergy() override;
+
+    /**
+     * Implements GetEnergyFraction. For the generic battery model, energy fraction
+     * is equivalent to the remaining usable capacity (i.e. The SoC).
+     *
+     * \return Energy fraction.
+     */
+    double GetEnergyFraction() override;
+
+    /**
+     * Implements UpdateEnergySource.
+     */
+    void UpdateEnergySource() override;
+
+    /**
+     * This function sets the interval between each energy update.
+     *
+     * \param interval Energy update interval.
+     */
+    void SetEnergyUpdateInterval(Time interval);
+
+    /**
+     *  This function is used to change the initial capacity in the battery.
+     *  A value of 0 means that the battery is fully charged. The value cannot
+     *  be set to a value bigger than the rated capacity (fully discharged) or
+     *  less than 0 (fully charged).
+     *
+     *  \param drainedCapacity The capacity drained so far in the battery.
+     */
+    void SetDrainedCapacity(double drainedCapacity);
+
+    /**
+     * Obtain the amount of drained capacity from the battery based on the
+     * integral of the current over time (Coulomb counting method).
+     *
+     * \return The drainedCapacity (Ah)
+     */
+    double GetDrainedCapacity() const;
+
+    /**
+     *  Calculates an estimate of the State of Charge (SoC).
+     *  In essence, the amount of usable capacity remaining in the battery (%).
+     *
+     *  \return The percentage of usable capacity remaining in the battery.
+     */
+    double GetStateOfCharge() const;
+
+    /**
+     * \return The interval between each energy update.
+     */
+    Time GetEnergyUpdateInterval() const;
+
+  private:
+    void DoInitialize() override;
+    void DoDispose() override;
+
+    /**
+     * Handles the battery reaching its cutoff voltage. This function notifies
+     * all the energy models aggregated to the node about the usable energy in the
+     * battery has being depleted. Each energy model is then responsible for its own handler.
+     */
+    void BatteryDepletedEvent();
+
+    /**
+     * Handles the battery reaching its full voltage. This function notifies
+     * all the energy models aggregated to the node about the battery reaching its
+     * full energy charge.
+     */
+    void BatteryChargedEvent();
+
+    /**
+     * Calculates remaining energy. This function uses the total current from all
+     * device models to calculate the amount of energy to decrease. The energy to
+     * decrease is given by:
+     *    energy to decrease = total current * supply voltage * time duration
+     * This function subtracts the calculated energy to decrease from remaining
+     * energy.
+     */
+    void CalculateRemainingEnergy();
+
+    /**
+     *  Get the battery voltage in function of the discharge current.
+     *  It consider different discharge curves for different discharge currents
+     *  and the remaining energy of the battery.
+     *
+     *  \param current The actual discharge current value (+i).
+     *  \return The voltage of the battery.
+     */
+    double GetVoltage(double current);
+
+    /**
+     *  Obtain the battery voltage as a result of a charge current.
+     *
+     *  \param current The actual charge current value (-i).
+     *  \return The voltage of the battery.
+     */
+    double GetChargeVoltage(double current);
+
+  private:
+    TracedValue<double> m_remainingEnergyJ; //!< Remaining energy, in Joules
+    double m_drainedCapacity;               //!< Capacity drained from the battery, in Ah
+    double m_currentFiltered;               //!< The step response (a.k.a. low pass filter)
+    double m_entn;                          //!< The previous value of the exponential zone
+                                            //!< in NiMh,NiCd and LeadAcid.
+    double m_expZone;                       //!< Voltage value of the exponential zone
+    Time m_energyUpdateLapseTime; //!< The lapse of time between the last battery energy update and
+                                  //!< the current time.
+    double m_supplyVoltageV;      //!< Actual voltage of the battery
+    double m_lowBatteryTh;        //!< Low battery threshold, as a fraction of the initial energy
+    EventId m_energyUpdateEvent;  //!< Energy update event
+    Time m_lastUpdateTime;        //!< Last update time
+    Time m_energyUpdateInterval;  //!< Energy update interval
+    double m_vFull;               //!< Initial voltage of the battery, in Volts
+    double m_vNom;                //!< Nominal voltage of the battery, in Volts
+    double m_vExp;                //!< Battery voltage at the end of the exponential zone, in Volts
+    double m_internalResistance;  //!< Internal resistance of the battery, in Ohms
+    double m_qMax;                //!< The maximum capacity of the battery, in Ah
+    double m_qNom;                //!< Battery capacity at the end of the nominal zone, in Ah
+    double m_qExp;                //!< Capacity value at the end of the exponential zone, in Ah
+    double m_typicalCurrent;      //!< Typical discharge current used to fit the curves
+    double m_cutoffVoltage; //!< The threshold voltage where the battery is considered depleted
+    GenericBatteryType m_batteryType; //!< Indicates the battery type used by the model
+};
+
+} // namespace ns3
+
+#endif /* GENERIC_BATTERY_MODEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/li-ion-energy-source.h ns-3.40/src/energy/model/li-ion-energy-source.h
--- ns-3.39/src/energy/model/li-ion-energy-source.h	2023-07-05 14:23:47.789427300 -0700
+++ ns-3.40/src/energy/model/li-ion-energy-source.h	2023-09-27 13:30:37.642839000 -0700
@@ -20,7 +20,8 @@
 #ifndef LI_ION_ENERGY_SOURCE_H
 #define LI_ION_ENERGY_SOURCE_H
 
-#include "ns3/energy-source.h"
+#include "energy-source.h"
+
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
 #include "ns3/traced-value.h"
@@ -32,6 +33,9 @@
  * \ingroup energy
  * \brief Model a generic Lithium Ion Battery basing on [1][2].
  *
+ * \deprecated The LiIonEnergySource was deprecated in ns-3.40 in favor of GenericBatteryModel, and
+ * will be removed in a future release.
+ *
  * The model can be fitted to any type of Li-Ion Battery, simply changing the
  * model parameters.
  * The default values are fitted for the Panasonic CGR18650DA Li-Ion Battery [3].
@@ -131,6 +135,7 @@
      *
      * Implements DecreaseRemainingEnergy.
      */
+    NS_DEPRECATED_3_40("Use GenericBatteryModel instead")
     virtual void DecreaseRemainingEnergy(double energyJ);
 
     /**
@@ -138,6 +143,7 @@
      *
      * Implements IncreaseRemainingEnergy.
      */
+    NS_DEPRECATED_3_40("Use GenericBatteryModel instead")
     virtual void IncreaseRemainingEnergy(double energyJ);
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/simple-device-energy-model.cc ns-3.40/src/energy/model/simple-device-energy-model.cc
--- ns-3.39/src/energy/model/simple-device-energy-model.cc	2023-07-05 14:23:47.789427300 -0700
+++ ns-3.40/src/energy/model/simple-device-energy-model.cc	2023-09-27 13:30:37.642839000 -0700
@@ -19,7 +19,8 @@
 
 #include "simple-device-energy-model.h"
 
-#include "ns3/energy-source.h"
+#include "energy-source.h"
+
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 #include "ns3/trace-source-accessor.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/energy/model/simple-device-energy-model.h ns-3.40/src/energy/model/simple-device-energy-model.h
--- ns-3.39/src/energy/model/simple-device-energy-model.h	2023-07-05 14:23:47.789427300 -0700
+++ ns-3.40/src/energy/model/simple-device-energy-model.h	2023-09-27 13:30:37.642839000 -0700
@@ -20,7 +20,8 @@
 #ifndef SIMPLE_DEVICE_ENERGY_MODEL_H
 #define SIMPLE_DEVICE_ENERGY_MODEL_H
 
-#include "ns3/device-energy-model.h"
+#include "device-energy-model.h"
+
 #include "ns3/nstime.h"
 #include "ns3/traced-value.h"
 
